package uaa.feral.physical.behaviors.data;

import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.IOException;


import simphony.util.messages.MessageCenter;
import uaa.feral.util.loader.ScenarioXMLFileLoader;

import com.thoughtworks.xstream.XStream;
import com.thoughtworks.xstream.io.xml.DomDriver;

public class HydrologyModelData implements PhysicalModelData {
	
	private double tickReset;
	private double degradeQuantity;
	private boolean degradeSystem;
	private String nameOfParticleTransportFile;
	private String additionalArgument;
	public static String OutputDirectory= "../FERAL/FERAL_Data/HydroModelData/";
	
	public HydrologyModelData(){
		
	}
	
	public HydrologyModelData setupModelData(String file){
		XStream xstream = new XStream(new DomDriver());
		xstream.setClassLoader(HydrologyModelData.class.getClassLoader());
		xstream.alias("HydroModelData",HydrologyModelData.class);
		xstream.aliasType("HydroModelData", HydrologyModelData.class);
		HydrologyModelData hmd=this;
		try {
			hmd=(HydrologyModelData)xstream.fromXML(new FileReader(file));
			
		} catch (Exception e) {
			MessageCenter.getMessageCenter(HydrologyModelData.class).error("Problems with reading" +
					"input XML file for Hydrology Model Data", e);
			e.printStackTrace();	

		}
		return hmd;
	}
	
	public static void main(String[] args) throws FileNotFoundException, IOException{
		XStream xstream = new XStream(new DomDriver());
		xstream.alias("HydroModelData",uaa.feral.social.data.AppliedSocialModelData.class);
		
		HydrologyModelData hmd = new HydrologyModelData();
		hmd.nameOfParticleTransportFile="C:/mt3dms5/utility/mt3dms.bat";
		hmd.additionalArgument="";
		xstream.setMode(XStream.XPATH_RELATIVE_REFERENCES);
		xstream.aliasType("HydroModelData", HydrologyModelData.class);
		String xml=xstream.toXML(hmd);
		String fileName= "HydroModelData2.xml";
		
		
		String filename= OutputDirectory+fileName;
		ScenarioXMLFileLoader.Output(xml,filename);
	}


	public double getDegradeQuantity() {
		return degradeQuantity;
	}

	public void setDegradeQuantity(double degradeQuantity) {
		this.degradeQuantity = degradeQuantity;
	}

	public boolean isDegradeSystem() {
		return degradeSystem;
	}

	public void setDegradeSystem(boolean degradeSystem) {
		this.degradeSystem = degradeSystem;
	}

	public double getTickReset() {
		return tickReset;
	}

	public void setTickReset(double tickReset) {
		this.tickReset = tickReset;
	}

	public String getNameOfParticleTransportFile() {
		return nameOfParticleTransportFile;
	}

	public void setNameOfParticleTransportFile(String nameOfParticleTransportFile) {
		this.nameOfParticleTransportFile = nameOfParticleTransportFile;
	}

	public String getAdditionalArgument() {
		return additionalArgument;
	}

	public void setAdditionalArgument(String additionalArgument) {
		this.additionalArgument = additionalArgument;
	}
}
