package uaa.feral.social.demographics;

import repast.simphony.random.RandomHelper;

import uaa.feral.social.Person;

/**
 * Class that implements default mortality/fertility functions, and is considered the 
 * generic object that performs these demographic functions for SAIL.
 * @author 
 */
public class StandardDemographicTable {

	private double[] probabilities;
	
	public StandardDemographicTable(){
	
	}
	
	public StandardDemographicTable(double [] probabilities){
		this.probabilities=probabilities;
	}
	
	/**
	 * Method that gets probability of death (or fertility if needed)
	 */
	public double demographicFunction(Person person) {
		double demoProb=0;
		
		try{
			demoProb=probabilities[person.getAge()];
		}
		catch(Exception e){
			demoProb=probabilities[probabilities.length-1];
		}
		
		return demoProb;
	}

	/**
	 * Method randomly determines sex
	 * @return a sex object
	 */
	public Sex determineSex(){
		double sexValue=RandomHelper.nextDouble();
		if(.5<sexValue)
			return Sex.MALE;
		else
			return Sex.FEMALE;
	}
	
	public double[] getProbabilities() {
		return probabilities;
	}
	
	public void setProbabilities(double[] probabilities) {
		this.probabilities = probabilities;
	}
	
	
}
