package uaa.feral.social.leadership;

import uaa.feral.social.Community;
import uaa.feral.util.data.ScenarioData;

public abstract class AbstractLeadershipModel implements LeadershipModel{

	ScenarioData scenarioData;
	
	/**
	 * Static method to create the desired model based on model's name. Community object is then set to the model
	 * @param model a model to create
	 * @param community the community to associate the model to
	 * @return a WaterUseModel object
	 */
	public static LeadershipModel CreateLeadershipModel(String model,ScenarioData sd,Community community){
		
		LeadershipModel leadershipModel=null;
		
		//create model to use
		if(model.equals("AgentTypesModel")){
			leadershipModel=new AgentTypesModel(community);
		}
		
		
		((AbstractLeadershipModel)leadershipModel).setScenarioData(sd);
		
		return leadershipModel;
	}
	
	public void setScenarioData(ScenarioData scenarioData) {
		this.scenarioData=scenarioData;
	}

	public ScenarioData getScenariodData() {
		return scenarioData;
	}
}
