package uaa.feral.social.network;

import repast.simphony.space.graph.RepastEdge;

/**
 * This network edge stores the relationship between the connected agents
 * 
 * @author 
 *
 * @param <T>
 */
public class RelationshipEdge<T> extends RepastEdge<T> {

	AgentType type;
	double approval;
	int sourceId;
	int targetId;
	
	/**
	 * Method to create a relationship edge
	 * @param source the person the relationship is relative to
	 * @param target the person who is related in the give way
	 * @param type the relationship type
	 */
	public RelationshipEdge(T source, T target, AgentType type) {
		super(source, target, true);
		this.approval=0;
		this.type = type;
	}

	public AgentType getType() {
		return type;
	}

	public double getApproval() {
		return approval;
	}

	public void setApproval(double approval) {
		this.approval = approval;
	}

	public void setType(AgentType type) {
		this.type = type;
	}

	public int getSourceId() {
		return sourceId;
	}

	public void setSourceId(int sourceId) {
		this.sourceId = sourceId;
	}

	public int getTargetId() {
		return targetId;
	}

	public void setTargetId(int targetId) {
		this.targetId = targetId;
	}
	
	public void setSourceTargetIds(int source,int target){
		this.sourceId=source;
		this.targetId=target;
	}
}
