package uaa.feral.social.waterUse;

import uaa.feral.social.GeneralModel;

/**
 * Interface for water use models
 * @author 
 */

public interface WaterUseModel extends GeneralModel{

	/**
	 * Method to see if water source preferences should be updated during the simulation
	 * @return a boolean if there is update preferences
	 */
	public boolean isUpdatePreferences();
	
	/**
	 * Method to see if simulation is for large scenarios 
	 * @return a boolean for large sims or not 
	 */
	public boolean isLargeSimulation();
	
	/**
	 * Set method for large sims or not
	 * @param largeSimulation the boolean for large sims or not
	 */
	public void setLargeSimulation(boolean largeSimulation);
	
	/**
	 * Set method for water quality degradation simulations
	 * @param degrade the boolean for degradation simulations
	 */
	public void setDegradeQualityMode(boolean degrade);

}
