package uaa.feral.util;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.StringTokenizer;

import simphony.util.messages.MessageCenter;
import uaa.feral.util.data.FilterData;

public class FilterDataOutput {

	public static List<String> filterFile(String fileName,String variableNames,double lessThan, double greaterThan, int remove){
		List<String> linesToInclude=null;
		try {
			File file = new File(fileName);
			 
			BufferedReader bufRdr  = new BufferedReader(new FileReader(file));
			String line = null;
			Map<Integer,String>includeThese=new HashMap<Integer,String>();
			linesToInclude=new ArrayList<String>();
			
//			read each line of file
			int row=0;
			while((line = bufRdr.readLine()) != null)
			{
				StringTokenizer st = new StringTokenizer(line,",");
				int col=0;
				while(st.hasMoreTokens()){
					String token=st.nextToken();
					if(row==0){
						token=token.substring(remove, token.length()-remove);
						if(variableNames.contains(token)){
							includeThese.put(col,token);
						}
					}
					else{
						if(includeThese.containsKey(col)){
							double value=Double.valueOf(token);
							if(value<=lessThan || greaterThan<=value){
								col++;
								continue;
							}
							else
								linesToInclude.add(line);
						}
					}
					col++;
				}
				row++;
			}
		}
		catch(IOException e){
			e.printStackTrace();
		}
		return linesToInclude;
	}
	
	public List<String> readTheseLines(String fileName){
		List<String> linesToInclude=null;
		try {
			File file = new File(fileName);
			 
			BufferedReader bufRdr  = new BufferedReader(new FileReader(file));
			linesToInclude=new ArrayList<String>();
			String line=null;
			int row=0;
			while((line = bufRdr.readLine()) != null)
			{
				if(row==0){
					row++;
					continue;
				}
	//			String line2=line.copyValueOf(line.toCharArray());
				if(line!=null)
					linesToInclude.add(line);
			}
		}
		
		catch(IOException e){
			
		}
		return linesToInclude;
	}
	
	public void printThisFile(List<String>printTheseLines,String titleLine,String fileName){
		FileWriter fw= null;
		PrintWriter pw= null;
	    System.out.println("writing output");
	    File file=null;
		file = new File(fileName);
		try{
			fw= new FileWriter( file );
			pw=  new PrintWriter( fw );
			pw.println(titleLine);
			for(int i=0; i < printTheseLines.size(); i++){
				pw.println(printTheseLines.get(i));
			}
			pw.close();
		}
		
		catch(IOException e2){
			MessageCenter.getMessageCenter(FilterDataOutput.class).error("Problems with reading" +
				"output file", e2);
		}
	}
	
	public static List<String> addTheseVariables(String names){
		String[] vars=names.split(",");
		List<String> variables=new ArrayList<String>();
		for(int i=0; i < vars.length; i++){
			variables.add(vars[i]);
		}
		return variables;
	}
	
	public static void main(String[] args){
		FilterData fd=null;
		FilterDataOutput fdo=new FilterDataOutput();
		for(int i=0; i < args.length; i++){
			String filter=args[i];
			if(filter.contains("Filter")){
				fd=FilterData.SetupFilterData(filter);
				String fileName=fd.getFileName();
				String variableTitles=fd.getVariableTitles();
				List<String>filterVariables=fd.getVariableNames();
				Map<String,Double>lessThan=fd.getLessThan();
				Map<String,Double>greaterThan=fd.getGreaterThan();
				Map<String, Integer>remove=fd.getRemove();
				
				for(int j=0; j < filterVariables.size();j++){
					String filterVariable = filterVariables.get(j);
					double lessT=lessThan.get(filterVariable);
					double greatT=greaterThan.get(filterVariable);
					int r=remove.get(filterVariable);
					List<String>printTheseLines=FilterDataOutput.filterFile(fileName, filterVariable, lessT,greatT,r);
					fdo.printThisFile(printTheseLines,variableTitles,fileName);
				}
			}
		}
	}		
}
