package uaa.feral.util.data;

/**
 * Class for holding references to data files and simulation info.
 * @author 
 */
public class ScenarioData {
	
	private String name;  //name of the community
	private String communityFile;  //path to community file
	private String hydrologicalFile;  //path to hydrology file
	private String streamFlowFile;  //path to stream data
	private String municipalFile; //path to municipal data fiel
	private String demographicFile;  //path to demographic data
	private String socialModelDataFile;  //path to xml water use model data
	private String miningFile;  //path to mining file
	private String hydroModelDataFile;  //file to hydrology model data
	private boolean municipalSystem=false;
	private boolean miningScenario=false; //flag for mining or not in scenario
	private boolean demographics=true; //default demographics are one
	private String waterUseModel;  //name of water use model
	private String miningWaterUseModel; // water use model for mining scenarios
	private String hydrologyModel;  //name of hydrology model
	private String leadershipModel;  //model on effective leadership for resilience adaptation
	private String socialNetworkFile;  //file on connections between individuals in a community
	
	public String getWaterUseModel() {
		return waterUseModel;
	}

	public void setWaterUseModel(String waterUseModel) {
		this.waterUseModel = waterUseModel;
	}

	public String getMiningWaterUseModel() {
		return miningWaterUseModel;
	}

	public void setMiningWaterUseModel(String miningWaterUseModel) {
		this.miningWaterUseModel = miningWaterUseModel;
	}

	public String getHydrologyModel() {
		return hydrologyModel;
	}

	public void setHydrologyModel(String hydrologyModel) {
		this.hydrologyModel = hydrologyModel;
	}

	public ScenarioData(){
		
	}
	
	public ScenarioData(String name,String communityFile){
		this.name=name;
		this.communityFile=communityFile;
	}
	
	public String getMiningFile() {
		return miningFile;
	}
	public void setMiningFile(String miningFile) {
		this.miningFile = miningFile;
	}
	public String getStreamFlowFile() {
		return streamFlowFile;
	}
	public void setStreamFlowFile(String streamFlowFile) {
		this.streamFlowFile = streamFlowFile;
	}
	public String getDemographicFile() {
		return demographicFile;
	}
	public void setDemographicFile(String demographicFile) {
		this.demographicFile = demographicFile;
	}
	public String getHydrologicalFile() {
		return hydrologicalFile;
	}
	public void setHydrologicalFile(String hydrologicalFile) {
		this.hydrologicalFile = hydrologicalFile;
	}
	public String getCommunityFile() {
		return communityFile;
	}
	public void setCommunityFile(String communityFile) {
		this.communityFile = communityFile;
	}
	public void setName(String name) {
		this.name = name;
	}
	public String getName() {
		return name;
	}
	public String getMunicipalFile() {
		return municipalFile;
	}
	public void setMunicipalFile(String municipalFile) {
		this.municipalFile = municipalFile;
	}
	public String getSocialModelDataFile() {
		return socialModelDataFile;
	}
	public void setSocialModelDataFile(String waterUseModelDataFile) {
		this.socialModelDataFile = waterUseModelDataFile;
	}
	public String getHydroModelDataFile() {
		return hydroModelDataFile;
	}
	public void setHydroModelDataFile(String hydroModelDataFile) {
		this.hydroModelDataFile = hydroModelDataFile;
	}
	public boolean isMunicipalSystem() {
		return municipalSystem;
	}
	public void setMunicipalSystem(boolean municipalSystem) {
		this.municipalSystem = municipalSystem;
	}	
	
	public boolean isMiningScenario() {
		return miningScenario;
	}
	public void setMiningScenario(boolean miningScenario) {
		this.miningScenario = miningScenario;
	}

	public String getLeadershipModel() {
		return leadershipModel;
	}

	public void setLeadershipModel(String leadershipModel) {
		this.leadershipModel = leadershipModel;
	}

	public String getSocialNetworkFile() {
		return socialNetworkFile;
	}

	public void setSocialNetworkFile(String socialNetworkFile) {
		this.socialNetworkFile = socialNetworkFile;
	}

	public boolean isDemographics() {
		return demographics;
	}

	public void setDemographics(boolean demographics) {
		this.demographics = demographics;
	}
}
