package uaa.feral.physical.behaviors;

import uaa.feral.util.Statistics;

/**
 * Testing class for VolumeEstimator model.
 * @author 
 */
public class VolumeEstimatorModelTest {

	/**
	 * Main used for testing volume estimator (Metropolis-Hastings Monte Carlo Method)
	 * @param args
	 */
	public static void main(String[] args){
		VolumeEstimatorModel vem = new VolumeEstimatorModel("test");
		
		double[] initValues={2000,1620,2200,1850,1950,1410,1740};  //initial values based on previous recorded discharges
		
		for(int i=0; i < 10; i++){
			double[] values=vem.estimateDischargeValue(initValues);
			System.out.println(Statistics.computeMedian(values, 0,values.length-1));
		
			double[] newVs=vem.estimateDischargeValue(values);
			System.out.println(Statistics.computeMedian(newVs, 0, newVs.length-1));
		
			double[] newVs2=vem.estimateDischargeValue(newVs);	
			System.out.println(Statistics.computeMedian(newVs2, 0, newVs2.length-1));
		
			double[] newVs3=vem.estimateDischargeValue(newVs2);
			System.out.println(Statistics.computeMedian(newVs3, 0, newVs3.length-1));
		
			double[] newVs4=vem.estimateDischargeValue(newVs3);
			System.out.println(Statistics.computeMedian(newVs4, 0, newVs4.length-1));
		}
	}
}
