package uaa.feral.util;

import com.vividsolutions.jts.geom.Coordinate;

import junit.framework.TestCase;

/**
 * Class for testing spatial hydrology calculations
 * @author 
 */
public class SpatialHydrologyCalculationsTest  extends TestCase{
	
	/**
	 * Test Distance 3D calculation
	 */
	public void testDistance3D(){
		Coordinate c1 = new Coordinate(2.0,3.0,1.0);
		Coordinate c2 = new Coordinate(7.0,8.0,6.0);
		
		double distance=SpatialHydrologyCalculations.LatLongDistance(c1, c2);
		assertTrue(distance>8.66 && distance<8.67);
	}
	
	/**
	 * Test daily volume calculator
	 */
	public void testDailyVolumeCalculator(){
		double volume=SpatialHydrologyCalculations.DailyVolumeCalculator(1000.1);
		assertTrue(volume==86408640d);
	}
}
